c###grid.for
      SUBROUTINE grid(luout,monthx,ihour,freqx,xxnoise)
c          for this code, ihour=time block (1-6)
c          and the grid will be done so as to match the plots of Report 322-3.
c          That means Longitude will go from 60E on the left and be cenetered at 120W.
C--------------------------------
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      common /c_version/ version
         character version*40
      character season_alf(12)*6,noise_code(4)*30,timeblock(6)*10
      character noise_alf(3)*2,equ*1,psum(4)*1,codes*5,psuma*1
      data noise_alf/' A',' G',' M'/
      data psum/'m','l','w','s'/
      data season_alf/'Winter','Winter','Spring','Spring',
     +                'Spring','Summer','Summer','Summer',
     +                'Autumn','Autumn','Autumn','Winter'/
      data noise_code/'Industrial (-140.4 MMN)',
     +                'Residential (-144.7 MMN)',
     +                'Rural (-150.0 MMN)',
     +                'Remote (-163.6 MMN)'/
      data timeblock/'0000-0400','0400-0800','0800-1200',
     +               '1200-1600','1600-2000','2000-2400'/
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
ccc      call setvars     !  set variables that are undefined
c*****************************************************************
c          mate MONTHs to SSNs per VOA request May 1993
c          required major changes to DECRED and following loop
      MONTH=monthx
      noise=xxnoise*10. + .5
      call REDMAP2(MONTH)
      freq=freqx
c*****************************************************************
      JT=ihour
      JTX = 1
      nx=61
      ny=61
      write(luout,'(''GH_NOISE'',2x,a)') version
      equ='n'       !  no equator interpolation
      if(mode_s2.ne.0) equ='i'     !  interpolate at equator
      psuma=psum(1)
      if(mode_l2.eq.1) psuma=psum(2)
      if(mode_l3.eq.1) psuma=psum(3)
      if(mode_l4.eq.1) psuma=psum(4)
      write(codes,'(5a1)') noise_alf(1)(mode_n1+1:mode_n1+1),
     +               noise_alf(2)(mode_n2+1:mode_n2+1),
     +               noise_alf(3)(mode_n3+1:mode_n3+1),equ,
     +               psuma
      if(noise.ge.1 .and. noise.le.4) then
      write(luout,3) season_alf(monthx),timeblock(ihour),freq,
     +               noise_code(noise),codes
3     format(a,' LT=',a,f7.3,'MHz',1x,a,' (',a5,')')
      else
      write(luout,1) season_alf(monthx),timeblock(ihour),freq,
     +              -xxnoise,codes
1     format(a,' LT=',a,f7.3,'MHz',f7.1,'MMN',' (',a5,')')
      end if
      write(luout,2) nx,ny
2     format(2i3,'  Latitude Longitude    NdBW     Fam',
     +           '      DL      DU SigmaLW  SigmaN SigmaUP    dFam')
ccc     +           '     Fam')
C.....CONVERT UT TO LMT, ETC.
      do 200 iy=1,ny
      rlatd=-90 + (iy-1)*3
      do 200 ix=1,nx
ccc      rlongd=-180 + (ix-1)*6
      rlongd=60 + (ix-1)*6     !  this will center plot at 120W
      if(rlongd.gt.180.) rlongd=rlongd-360.
      RLAT = RLATD * D2R
      RLONG = RLONGD * D2R
      if(abs(rlatd).gt.89.9) rlong=0.     !  at poles, force long=0
      if(abs(tlatd).gt.89.9) tlong=0.     !  at poles, force long=0
      CALL GEOTIM(JT)
      call anois1(ihour)       !  get noise value at 1 MHz for receiver site
c                          !  noise distribution
      call genois(xnoise,xdu,xdl,xsigm,xsygu,xsygl,xnoiseS)
      write(luout,101) ix,iy,rlatd,rlongd,
     +            xnoise,xnoise+204.,xdl,xdu,xsygl,xsigm,xsygu
     +            ,xnoise-xnoiseS     !  diff from power sum
ccc     +           ,xn_atnos+204.
101   format(2i3,2f10.4,8f8.2)
200   continue

      RETURN
      END
C---------------------------------
