
      integer*4 function mouseCB()
      parameter (NGRID_DIM=361)
      INCLUDE <WINDOWS.INS>
      common /LAST_PARM/ iplast        !  =0=map only
      COMMON /RUNDATA/ XMINL,YMINL,DX,DY,NX,NY
      COMMON /MAXS/ XMAXL,YMAXL
      common /proj/ iproj,plat,plon
      common /cparameter/ scfact,xparameter
         character xparameter*8
      common /cgridvals/ gridvals(NGRID_DIM,NGRID_DIM,8)
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)  
      common /mouse_results/ mouse_message,minsxx,maxsxx,minsyy,maxsyy,
     +                       xxscal,yyscal,wxxmin,wyymin,lenyy
         character mouse_message*100
      integer*2 ih,iv
      dimension nx_array(2)
      character pole*6
      nx_array(1)=61
      if(nx.gt.61) nx_array(1)=nx
      nx_array(2)=nx
      mouse_message='Pick (x,y) location for readout'
      call get_mouse_info@(ix,iy,iflag)
      jy=lenyy-1-iy
      if(ix.lt.minsxx .or. ix.gt.maxsxx) go to 999    !  outside plot area
      if(jy.lt.minsyy .or. jy.gt.maxsyy) go to 999    !  outside plot area
      x=float(ix-minsxx)/xxscal + wxxmin
      if(iproj.ne.7) x=x+plon
      y=float(jy-minsyy)/yyscal + wyymin
c***********************************************************************
      call proj_inv(x,y,xlong,xlat)   !  convert to Lat/Long
      ixx=index_get(x,xminl,xmaxl,nx_array(iflag),iflag)
      iyy=index_get(y,yminl,ymaxl,nx_array(iflag),iflag)
      if(iflag.eq.1) then             !  left mouse button = exact value
         if(iplast.ne.0) then
            z1=grid(ixx  ,iyy  )
            z2=grid(ixx  ,iyy+1)
            z3=grid(ixx+1,iyy+1)
            z4=grid(ixx+1,iyy  )
            dxx=(xmaxl-xminl)/float(nx_array(1)-1)
            dyy=(ymaxl-yminl)/float(nx_array(1)-1)
            xx=xminl + dxx*float(ixx-1)
            yy=yminl + dyy*float(iyy-1)
            z14=z1 + (z4-z1)*(x-xx)/dxx
            z23=z2 + (z3-z2)*(x-xx)/dxx
            val=z14 + (z23-z14)*(y-yy)/dyy
         end if
      else                            !  otherwise, closest grid point
         xx=xminl + dx*float(ixx-1)
         yy=yminl + dy*float(iyy-1)
         x=xx
         y=yy
         call proj_inv(x,y,xlong,xlat)   !  convert to Lat/Long
ccc         if(iproj.ne.7) xlong=xlong+plon
         if(iplast.ne.0) val=gridvals(ixx,iyy,iplast)*scfact
         if(iproj.ne.7) xx=xx-plon
         ih=nint((xx-wxxmin)*xxscal + float(minsxx))
         iv=nint((yy-wyymin)*yyscal + float(minsyy))
         iv=lenyy-1-iv
         call set_mouse_position@(ih,iv)
      end if
c***********************************************************************
      if(iproj.ne.7) go to 100     !  Lat/Lon projection
      if(iplast.ne.0) then
         write(mouse_message,1) nint(x),nint(y),xlat,xlong,xparameter,
     +        val
1        format(1h(,i6,1h,,i6,')km (',f6.2,'lat ',f7.2,'lon) ',a8,1h=,
     +        f8.2)
      else                         !  MAP ONLY
         write(mouse_message,2) nint(x),nint(y),xlat,xlong
2        format(1h(,i6,1h,,i6,')km (',f6.2,'lat ',f7.2,'lon) ')
      end if
      go to 999
100   if(iplast.ne.0) then
       if(abs(xlat).gt.89.9) then      !  at a pole
         pole='North'
         if(xlat.lt.0.) pole='South'
         write(mouse_message,3) pole,xparameter,val
3        format('(',a,'pole) ',a8,1h=,f8.2)
       else
         write(mouse_message,4) xlat,xlong,xparameter,val
4        format('(',f6.2,'lat ',f7.2,'lon) ',a8,1h=,f8.2)
       end if
      else                         !  MAP ONLY
       if(abs(xlat).gt.89.9) then      !  at a pole
         pole='North'
         if(xlat.lt.0.) pole='South'
         write(mouse_message,5) pole
5        format('(',a,'pole) ')
       else                         !  MAP ONLY
         write(mouse_message,6) xlat,xlong
6        format('(',f6.2,'lat ',f7.2,'lon) ')
       end if
      end if
999   call window_update@(mouse_message)
      mouseCB=1
      return
      end
c----------------------------------------------------------------
      subroutine mouse_set_scale
      common /mouse_results/ mouse_message,minsxx,maxsxx,minsyy,maxsyy,
     +                       xxscal,yyscal,wxxmin,wyymin,lenyy
         character mouse_message*100
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      minsxx=minsx
      maxsxx=maxsx
      minsyy=minsy
      maxsyy=maxsy
      xxscal=xscal
      yyscal=yscal
      wxxmin=wxmin
      wyymin=wymin
      lenyy=leny
      return
      end
c----------------------------------------------------------------
      function index_get(x,xmin,xmax,nx,iflag)
      dx=(xmax-xmin)/float(nx-1)
      index_get=(x-xmin)/dx + .5*float(iflag-1) + 1.
      return
      end
c----------------------------------------------------------------
