      subroutine RECTANG(IX0,IY0,IX1,IY1,icolor_inside,ifill_code,
     +                   icolor_border)
c          ifill_code = shading code to fill with (0=solid)
c          icolor_border = -1 = do not draw border
c          icolor_inside = -1 = do not fill inside
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      integer*2 icol2,jx0,jy0,jx1,jy1
      jx0=ix0
      jx1=ix1
      jy0=leny-1-iy1
      jy1=leny-1-iy0
      if(idev.ne.0) then
         jx0=jx0+ixoff
         jy0=jy0+iyoff
         jx1=jx1+ixoff
         jy1=jy1+iyoff
      end if
      if(ifill_code.gt.0) go to 100     !  not solid fill
      icol2=icolor_inside
      if(icolor_inside.ge.0)
     +call fill_rectangle@(jx0,jy0,jx1,jy1,icol2)
      icol2=icolor_border
      if(icolor_border.ge.0)
     +call rectangle@(jx0,jy0,jx1,jy1,icol2)
      RETURN
c          fill with shading
100   icol2=icolor_border
      if(icolor_border.ge.0)
     +call rectangle@(jx0,jy0,jx1,jy1,icol2)
      if(icolor_inside.ge.0)
     +call rectshad(ifill_code,ix0,iy0,ix1,iy1,icolor_inside)
      RETURN
      END
C------------------------------------------------------------------
      subroutine rectshad(maskidx,minx,miny,maxx,maxy,icolor_inside)
c          maskidx = 0 = solid fill (should not be in this routine)
c                  = n = shade using fill mask index n
      integer*1 mask(8)
      integer*4 mask2,jx,msk(8)
      data msk/1,2,4,8,16,32,64,128/
      if(maskidx.gt.0) call getfill(maskidx,mask)
      do 100 iyp=miny,maxy
      do 100 ixp=minx,maxx
      jx=mod(ixp,8)
      jy=mod(iyp,8)+1
      mask2=mask(jy)
      if(iand(mask2,msk(jx+1)).ne.0) 
     +        call doti(ixp,iyp,icolor_inside)
100   continue
      return
      end
c------------------------------------------------------------------
