
      subroutine shadebw            !  Black/White BIN shading
      parameter (NGRID_DIM=361)
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)  
      common /rundata/ xmin,ymin,dx,dy,nx,ny
      common /cons/ ncolor,con(200),icolor(200)
      dimension z(4)
      iblack=icol_16(0)         !  make all lines black
      do 100 iy=2,ny
      y0=ymin + float(iy-2)*dy
      y1=y0+dy
      do 90 ix=2,nx
      x0=xmin + float(ix-2)*dx
      x1=x0+dx
      z(1)=grid(ix-1,iy-1)
      if(z(1).lt.-32000.) go to 90         !  bad data value
      z(2)=grid(ix-1,iy)
      if(z(2).lt.-32000.) go to 90         !  bad data value
      z(3)=grid(ix  ,iy)
      if(z(3).lt.-32000.) go to 90         !  bad data value
      z(4)=grid(ix  ,iy-1)
      if(z(4).lt.-32000.) go to 90         !  bad data value
      zave=(z(1)+z(2)+z(3)+z(4))/4.      !  average of cell
      call plotxy(x0,y0,u,v)
      ix0=u+.5
      iy0=v+.5
      call plotxy(x1,y1,u,v)
      ix1=u+.5
      iy1=v+.5
      do 20 i=1,ncolor            !  color whole cell 1 color
      if(zave.lt.con(i)) go to 50
20    continue
      i=ncolor
50    continue
      ishade=icolor(i)
      call rectang(ix0,iy0,ix1,iy1,iblack,ishade,iblack)
90    continue
100   continue
      return
      end
c------------------------------------------------------------------
