      subroutine slabl(model,map_only,label,lfile,parameter)
      character model*6,map_only*1,label*(*),lfile*(*)
      common /hpgcom/ wxmin,wxmax,wymin,wymax,minsx,maxsx,
     +                minsy,maxsy,xscal,yscal,lenx,leny
      common /Cinfo/ info,time_alf
         character info*30,time_alf*20
      character parameter*8,alf*50,noise_lab*3,equator*1
      character label1*80,label2*80,label_all*80,codes*5,psum*1
      character psum_label*60
      label_all=label
      nch=lenchar(label_all)
      codes=label_all(nch-5:nch-1)
      noise_lab=codes(1:3)
      equator=codes(4:4)    !  equator interpolation?
      psum=codes(5:5)       !  power sum flag
      if(psum.eq.'m') then
         psum_label='Power Sum - Modified Spaulding'
      else if(psum.eq.'l') then
         psum_label='Power Sum - Limit DU/DL to 12dB'
      else if(psum.eq.'w') then
         psum_label='Power Sum - Original Spaulding'
      else if(psum.eq.'s') then
         psum_label='Simple Power Sum'
      end if
      label2=label_all(1:nch-7)
      if(noise_lab.eq.'AGM') then
        label1='Noise source (Atmospheric + Galactic + Man-Made)'
      else if(noise_lab.eq.'AG ') then
        label1='Noise source (Atmospheric + Galactic)'
      else if(noise_lab.eq.'A M') then
        label1='Noise source (Atmospheric + Man-Made)'
      else if(noise_lab.eq.' GM') then
        label1='Noise source (Galactic + Man-Made)'
      else if(noise_lab.eq.'A  ') then
        label1='Noise source (Atmospheric)'
      else if(noise_lab.eq.' G ') then
        label1='Noise source (Galactic)'
      else if(noise_lab.eq.'  M') then
        label1='Noise source (Man-Made)'
      end if
      nch=lenchar(label1)      !  # chars in label
      if(nch.lt.1) nch=1
      call jclpw(0)
      size=.8
      ires=iresolut()     !  screen resolution
      if(ires.eq.1) size=.9           !  text for 640x480 bigger
10    call setext(3,size,0.,0.,ichx,ichy)
      call charget(chx,chy)
      ichx=chx
      lenlabel=lentext(label1(1:nch))
      if(float(lenlabel)/float(lenx).le..9) go to 20
      size=size*.95     !  make text smaller so label will fit
      go to 10
20    ixp=(lenx-lenlabel)/2.
      iyp=leny-chy*6./4.
      if(ixp.lt.ichx+1) ixp=ichx+1
      iyp=iyp-ichy/2
      call ploti(ixp,iyp,3)
      if(nch.gt.2) call textc(nch,label1)   !  plot title
      nch=lenchar(label2)
      lenlabel=lentext(label2(1:nch))
      ixp=(lenx-lenlabel)/2.
      iypp=iyp-ichy*3/2
      call ploti(ixp,iypp,3)
      call textc(nch,label2)   !  plot title
      nch=lenchar(psum_label)
      lenlabel=lentext(psum_label(1:nch))
      ixp=(lenx-lenlabel)/2.
      iypp=iypp-ichy*3/2
      call ploti(ixp,iypp,3)
      call textc(nch,psum_label)   !  plot power sum label
      if(equator.eq.'i') then
         label2='Equator interpolation'
         nch=lenchar(label2)
         lenlabel=lentext(label2(1:nch))
         ixp=(lenx-lenlabel)/2.
         iypp=iypp-ichy*3/2
         call ploti(ixp,iypp,3)
         call textc(nch,label2)   !  plot title
      end if

      call setext(4,1.,0.,0.,ichx,ichy)       !  bold text
      call charget(chx,chy)
         nchp=lenchar(parameter)
         if(nchp.lt.1) nchp=1
         ixp=lenx-.5*chx - lentext(parameter(1:nchp))
         iyp=iyp-ichy/2
         call ploti(ixp,iyp-ichy/2,3)
         call textc(nchp,parameter)
         nch=lenchar(lfile)
         if(nch.lt.1) nch=1
         alf=lfile(1:nch)
         nch=lenchar(alf)
         ixp=lenx-.5*chx - lentext(alf(1:nch))
         iyp=iyp-ichy*7/4
         call ploti(ixp,iyp,3)
         call textc(nch,alf)  !  filename
c**************************************************************
100   call logo(lenx,leny)
      call jclpw(1)
      call jmcur
      return
      end
c-----------------------------------------------------------------
