      subroutine SGRID(size)
      COMMON /BLOK1/ DD1(2),IDD1(2),WW(4),IDD2(2),DD2(8)
      COMMON /PROJP/ W(4),NSTEP,ISUB,ICONT,JPROJ,POLAT,POLONG,ROT,
     +               JLTS,IGRID,PL1(2),PL2(2),PL3(2),PL4(2)
      EQUIVALENCE (W(1),XLONG1),(W(2),XLONG2),(W(3),YLAT1),(W(4),YLAT2)
      character label*35
      call setext(3,size,0.,0.,ichx,ichy)
      size_new=size*1.4
      CALL FRAME(WW(1),WW(2),WW(3),WW(4))
      IF(IGRID.EQ.0) GO TO 900     !  DON'T PLOT A GRID
      CALL CHARGET(CHX,CHY)
      TICK=CHX/4.
      XINC=ABS(IGRID)
      YINC=XINC
      yinc=10.
      IF(IGRID.EQ.360) YINC=180
      ylab=yinc
      if(ylat2-ylat1.gt.100.) ylab=30.
      xlab=xinc
      if(xlong2-xlong1.gt.200.) xlab=30.
c     CALL JJUST(1.,.3)
      ISIGN=0
      IF(YLAT1*YLAT2.LT.0.) ISIGN=1
      IF(IGRID.GT.0) GO TO 45
C******************************************* ONLY TICK MARKS
      CALL JCLPW(0)
      DO 20 Y=YLAT1,YLAT2,YINC
20    CALL TICKLL(XLONG2,Y,TICK,0.)
      DO 25 Y=YLAT2,YLAT1,-YINC
25    CALL TICKLL(XLONG1,Y,-TICK,0.)
      GO TO 65
C*******************************************
45    ISWTCH=0
      DO 60 Y=YLAT1,YLAT2,YINC
      IPEN=3
	dx=1
	if(xlong2-xlong1.eq.360) dx=10
      DO 50 X=XLONG1,XLONG2,dx
      XX=X
      IF(ISWTCH.NE.0) XX=XLONG1+XLONG2-X
      CALL PLOTLL(XX,Y,IPEN)
50    IPEN=2
      ISWTCH=1-ISWTCH
60    CONTINUE
65    IF(JPROJ.NE.8) GO TO 71   !  ONLY LABEL CYLINDRICAL
      CALL JCLPW(0)
      DO 68 Y=YLAT1,YLAT2,ylab
      call supcon(y,xlong1,u,v)
      call plotxy(u,v,uu,vv)
      call plotabs(uu,vv,3)
68    call plotabs(uu-chx/4.,vv,2)
      DO 70 Y=YLAT1,YLAT2,ylab
70    CALL LABLL(XLONG1,Y,-1,0,Y,ISIGN,1)
      CALL JCLPW(0)
      YY=(YLAT1 + YLAT2)/2.
      CALL SUPCON(YY,XLONG1,U,V)
      ires=iresolut()           !  screen resolution
      if(ires.gt.0) then
         call setext(3,size_new,90.,0.,ichxx,ichyy)    !  screen
      else
         call printcap(ipixels,itext)   !  get printer capabilities
         if(itext.eq.0) then         !  cannot rotate text, use vector text
            call setext(101,size_new,90.,0.,ichxx,ichyy)
         else
            call setext(3,size_new,90.,0.,ichxx,ichyy)
         end if
      end if
      NS=1                      !  NORTH label
      IF(YLAT2.LE.0.) NS=-1     !  SOUTH label
      IF(NS.GT.0) label='GEOGRAPHIC LATITUDE (DEGREES NORTH)'
      IF(NS.LT.0) label='GEOGRAPHIC LATITUDE (DEGREES SOUTH)'
      CALL PLOTXYi(U,V,iUU,iVV)
      len=lentext(label)
      CALL PLOTi(iUU-iCHX*5,iVV-len/2,3)
      CALL TEXTC(35,label)
 71	continue
      call setext(3,size,0.,0.,ichx,ichy)
c     CALL JJUST(0.,0.)
      CALL JCLPW(1)
      ISWTCH=0
      DX=XLONG2-XLONG1
c     CALL JJUST(.5,1.)
      ISIGN=0
      IF(XLONG1*XLONG2.LT.0.) ISIGN=1
      IF(IGRID.GT.0) GO TO 89
C*******************************************  ONLY TICK MARKS
      CALL JCLPW(0)
      DO 72 X=XLONG1,XLONG2,XINC
72    CALL TICKLL(X,YLAT2,0.,TICK)
      DO 75 X=XLONG2,XLONG1,-XINC
75    CALL TICKLL(X,YLAT1,0.,-TICK)
      GO TO 105
C*******************************************
89    DO 100 XX=XLONG1,XLONG2,XINC
      IX=XX + .5*SIGN(1.,XX)
      IPEN=3
	dy=1
	if(ylat2-ylat1.eq.180) dy=10
      DO 90 Y=YLAT1,YLAT2,dy
      YY=Y
      IF(ISWTCH.EQ.1) YY=YLAT1+YLAT2-Y
      IF(JPROJ.EQ.8 .OR. JPROJ.EQ.9) GO TO 85  !  CYLINDRICAL PROJ
      IF(DX.LT.360.) GO TO 85   !  NOT WHOLE LONGITUDE
      IF(ABS(YY).LE.70.) GO TO 85
      IF(IX.NE.(IX/45)*45 .AND. IX.NE.(IX/30)*30) GO TO 90
      IF(ABS(YY).LE.80.) GO TO 85
      IF(IX.NE.(IX/90)*90) GO TO 90
85    CALL PLOTLL(XX,YY,IPEN)
      IPEN=2
90    CONTINUE
      ISWTCH=1-ISWTCH
100   CONTINUE
105   IF(JPROJ.NE.8) GO TO 111  !  ONLY LABEL CYLINDRICAL
      CALL JCLPW(0)
      DO 108 XX=XLONG1,XLONG2,xlab
      call supcon(ylat1,xx,u,v)
      call plotxy(u,v,uu,vv)
      call plotabs(uu,vv,3)
108   call plotabs(uu,vv-chy/4.,2)
      DO 110 XX=XLONG1,XLONG2,xlab
110   CALL LABLL(XX,YLAT1,0,-1,XX,ISIGN,0)
      CALL JCLPW(0)
      XX=(XLONG1+XLONG2)/2.
      CALL SUPCON(YLAT1,XX,U,V)
      IEW=1                     !  EAST  label
      IF(XLONG2.LE.0.) IEW=-1   !  WEST  label
      IF(XLONG1.GT.180.) IEW=-1 !  WEST  label
      IF(IEW.GT.0) label='GEOGRAPHIC LONGITUDE (DEGREES EAST)'
      IF(IEW.LT.0) label='GEOGRAPHIC LONGITUDE (DEGREES WEST)'
      call setext(3,size_new,0.,0.,ichx,ichy)
      len=lentext(label)
      CALL PLOTXYi(U,V,iUU,iVV)
      CALL PLOTi(iUU-len/2,iVV-iCHY*4,3)
      CALL TEXTC(35,label)
111	continue 
c     CALL JJUST(0.,0.)
      CALL JCLPW(1)
900   CALL JMCUR
      call setext(3,size,0.,0.,ichx,ichy)
      RETURN
      END
C--------------------------------------------------------------------
