      
      subroutine shade
      parameter (NGRID_DIM=361)
      common /print_done/ pct_done,s_pct_done,icancel_print
         character s_pct_done*4
         real*8 pct_done
      character s_last*4
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)  
      common /rundata/ xmin,ymin,dx,dy,nx,ny
      common /proj/ iproj,plat,plon
      dimension z(4)
      idone=0
      total=nx*ny
ccc      write(15,'('' dx,dy='',2f10.4)') dx,dy
      do 100 iy=2,ny
      y0=ymin + float(iy-2)*dy
      y1=y0+dy
      if(idev.ne.0) call yieldit    !  yield for printers
ccc      if(idev.ne.0 .and. iy.gt.5) go to 100
      do 90 ix=2,nx
      x0=xmin + float(ix-2)*dx
      x1=x0+dx
      z(1)=grid(ix-1,iy-1)
      z(2)=grid(ix-1,iy)
      z(3)=grid(ix  ,iy)
      z(4)=grid(ix  ,iy-1)
      zmin=z(1)
      if(z(2).lt.zmin) zmin=z(2)
      if(z(3).lt.zmin) zmin=z(3)
      if(z(4).lt.zmin) zmin=z(4)
      if(zmin.lt.-32000.) go to 90    !  skip any bad data
      if(iproj.eq.8) then    !  force projection center for Lat/Lon projection
         call supcon(y0,x0,uu,vv)
         call plotxy(uu,vv,u,v)
         ix0=u+.5
         iy0=v+.5
         call supcon(y1,x1,uu,vv)
         call plotxy(uu,vv,u,v)
         ix1=u+.5
         iy1=v+.5
         if(ix1.lt.ix0) then !  problems at long=180
            xx1=x1-.001
            call supcon(y1,xx1,uu,vv)
            call plotxy(uu,vv,u,v)
            ix1=u+.5
            iy1=v+.5
         end if
      else                   !  great circle projection
         call plotxy(x0,y0,u,v)
         ix0=u+.5
         iy0=v+.5
         call plotxy(x1,y1,u,v)
         ix1=u+.5
         iy1=v+.5
      end if
ccc      if(iy.lt.10) then
ccc      write(15,111) ix,iy,x0,y0,x1,y1,ix0,iy0,ix1,iy1,z
ccc111   format(2i3,4f6.1,4i5,4f6.1)
ccc      end if
      call fill(ix0,iy0,ix1,iy1,z)
      if(idev.ne.0) then
         if(icancel_print.ne.0) return    !  printing was cancelled
         idone=idone+1
         pct_done=float(idone)/total
         s_last=s_pct_done
         write(s_pct_done,'(i3,1h%)') nint(pct_done*100.)
         if(s_last.ne.s_pct_done) call window_update@(s_pct_done)
      end if
90    continue
100   continue
      return
      end
c------------------------------------------------------------------
      subroutine fill(ix0,iy0,ix1,iy1,z)
      dimension z(4),zz(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
c          break cell into 4 quarters and try again
      do 100 iq=1,4
      call quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
100   call fill1(jx0,jy0,jx1,jy1,zz)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine fill1(ix0,iy0,ix1,iy1,z)
      dimension z(4),zz(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
c          break cell into 4 quarters and try again
      do 100 iq=1,4
      call quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
100   call fill2(jx0,jy0,jx1,jy1,zz)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine fill2(ix0,iy0,ix1,iy1,z)
      dimension z(4),zz(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
c          break cell into 4 quarters and try again
      do 100 iq=1,4
      call quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
100   call fill3(jx0,jy0,jx1,jy1,zz)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine fill3(ix0,iy0,ix1,iy1,z)
      dimension z(4),zz(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
c          break cell into 4 quarters and try again
      do 100 iq=1,4
      call quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
100   call fill4(jx0,jy0,jx1,jy1,zz)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine fill4(ix0,iy0,ix1,iy1,z)
      dimension z(4),zz(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
c          break cell into 4 quarters and try again
      do 100 iq=1,4
      call quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
100   call fill5(jx0,jy0,jx1,jy1,zz)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine fill5(ix0,iy0,ix1,iy1,z)
      dimension z(4),zz(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
c          break cell into 4 quarters and try again
      do 100 iq=1,4
      call quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
100   call fill6(jx0,jy0,jx1,jy1,zz)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine fill6(ix0,iy0,ix1,iy1,z)
      dimension z(4)
      call easy(ix0,iy0,ix1,iy1,z,*999)
c******************************************************************
ccc      call jmcur
cccc      call initt(0)
cccc      write(6,1) z
cccc1     format(15H need fill7  z=,4f10.3)
c******************************************************************
999   return
      end
c------------------------------------------------------------------
      subroutine quarter(ix0,iy0,ix1,iy1,z,iq,jx0,jy0,jx1,jy1,zz)
      dimension z(4),zz(4)
      zave=(z(1)+z(2)+z(3)+z(4))/4.
      ixc=float(ix0+ix1)/2. + .5
      iyc=float(iy0+iy1)/2. + .5
      go to (100,200,300,400),iq
c          lower left
100   jx0=ix0
      jy0=iy0
      jx1=ixc
      jy1=iyc
      zz(1)=z(1)
      zz(2)=(z(1)+z(2))/2.
      zz(3)=zave
      zz(4)=(z(1)+z(4))/2.
      return
c          upper left
200   jx0=ix0
      jy0=iyc
      jx1=ixc
      jy1=iy1
      zz(1)=(z(1)+z(2))/2.
      zz(2)=z(2)
      zz(3)=(z(2)+z(3))/2.
      zz(4)=zave
      return
c          upper right
300   jx0=ixc
      jy0=iyc
      jx1=ix1
      jy1=iy1
      zz(1)=zave
      zz(2)=(z(2)+z(3))/2.
      zz(3)=z(3)
      zz(4)=(z(3)+z(4))/2.
      return
c          lower right
400   jx0=ixc
      jy0=iy0
      jx1=ix1
      jy1=iyc
      zz(1)=(z(1)+z(4))/2.
      zz(2)=zave
      zz(3)=(z(3)+z(4))/2.
      zz(4)=z(4)
      return
      end
c------------------------------------------------------------------
      subroutine easy(ix0,iy0,ix1,iy1,z,*)
      common /cons/ ncolor,con(200),icolor(200)
      dimension z(4)
      zmin=z(1)
      zmax=z(1)
      do 10 i=2,4
      if(z(i).lt.zmin) zmin=z(i)
      if(z(i).gt.zmax) zmax=z(i)
10    continue
      if(zmin.lt.-32000.) go to 999        !  bad data value
c          see if whole cell is one color
      i=1
      ilow=0
      ihi=0
      if(zmin.le.con(1)) ilow=1
      if(zmax.le.con(1)) go to 900         !  <= 1st
      if(zmax.gt.con(1)) ihi=2
      do 20 i=2,ncolor
      if(zmin.gt.con(i-1) .and. zmax.le.con(i)) go to 900
      if(ilow.eq.0 .and. zmin.le.con(i)) ilow=i
      if(zmax.gt.con(i)) ihi=i+1
20    continue
      if(ihi-ilow.gt.1) return  !  break cell into quarters
      call simple(con(ilow),icolor(ilow),icolor(ihi),ix0,iy0,ix1,iy1,z,
     +                          *800)
      go to 999
800   return                    !  not as simple as we thought!!
c******************************************************************
c          color whole cell one color
900   continue
      icol=icol_16(icolor(i))
czzz      call rectang(ix0,iy0,ix1,iy1,icol,0,-1)
      call rectang(ix0,iy0,ix1,iy1,icol,0,icol)
ccc      write(15,'('' whole cell='',4i5,1h=,i3)') 
ccc     +           ix0,iy0,ix1,iy1,icolor(i)
999   return 1
      end
c------------------------------------------------------------------
      subroutine simple(con,lowcol,ihicol,ix0,iy0,ix1,iy1,z,*)
      dimension z(4)
      dimension ix(8),iy(8),nodept(2,8),iside(4),ii(2),iused(8)
      integer*2 npts,handle,error_code,icol2
      integer*2 ixx(20),iyy(20)
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      COMMON /HPGCOM/ WXMIN,WXMAX,WYMIN,WYMAX,MINSX,MAXSX,
     +                MINSY,MAXSY,XSCAL,YSCAL,LENX,LENY
      data nodept/2,0,3,0,4,0,5,0,6,0,7,0,8,0,1,0/
ccc      write(6,'('' In simple='',4i6,'' z='',4f10.5)')
ccc     +   ix0,iy0,ix1,iy1,z
      ix(1)=ix0
      iy(1)=iy0
      ix(2)=ix0
      iy(2)=(iy0+iy1)/2
      ix(3)=ix0
      iy(3)=iy1
      ix(4)=(ix0+ix1)/2
      iy(4)=iy1
      ix(5)=ix1
      iy(5)=iy1
      ix(6)=ix1
      iy(6)=iy(2)
      ix(7)=ix1
      iy(7)=iy0
      ix(8)=ix(4)
      iy(8)=iy0
      do 5 i=1,8
      iused(i)=0
5     nodept(2,i)=0
      call interp(z(1),z(2),con,iy0,iy1,ix0,iy(2),ix(2),iside(1))
      call interp(z(2),z(3),con,ix0,ix1,iy1,ix(4),iy(4),iside(2))
      call interp(z(4),z(3),con,iy0,iy1,ix1,iy(6),ix(6),iside(3))
      call interp(z(1),z(4),con,ix0,ix1,iy0,ix(8),iy(8),iside(4))
      n=iside(1)+iside(2)+iside(3)+iside(4)
      if(n.eq.4) return 1       !  not simple -- ridge problem
      icol=icol_16(ihicol)
czzz      call rectang(ix0,iy0,ix1,iy1,icol,0,-1)
cxxx      call rectang(ix0,iy0,ix1,iy1,icol,0,icol)
ccc      write(15,'('' Simple    ='',4i5,1h=,i3)') 
ccc     +           ix0,iy0,ix1,iy1,ihicol
      if(n.eq.2) go to 10
ccc      call jmcur
      write(*,1) n,con,z
1     format(3H n=,i4,5H con=,f10.4,5H   z=,4f10.4)
      write(*,'(12H iside[1-4]=,4i4)') iside
      stop 'error in simple'
10    nn=0
      do 15 i=1,4
      if(iside(i).eq.0) go to 15
      nn=nn+1
      ii(nn)=i*2
15    continue
      nodept(2,ii(1))=ii(2)
      nodept(2,ii(2))=ii(1)
ccc   call jmcur
ccc   write(6,1) n,con,z
ccc   write(6,2) iside,ii,nodept
c2    format(7H iside=,4i1,4H ii=,2i3,8H nodept=,8(i4,i2))
ccc   write(6,3) (ix(j),iy(j),j=1,8)
c3    format(7H ix,iy=,8(i6,i5))
      icol2=icol_16(ihicol)
ccc      if(icol2.ne.-9934) go to 101
      do 100 nodest=1,7,2
      zz=z((nodest+1)/2)
      if(con.ge.zz) go to 100   !  node is high color
      if(iused(nodest).ne.0) go to 100     !  already used
      npts=1
      ixx(npts)=ix(nodest)
      iyy(npts)=iy(nodest)
      lx=ix(nodest)
      ly=iy(nodest)
      iused(nodest)=1
      last=0
      next=nodest
30    if(nodept(2,next).ne.0) go to 50
35    last=next
      next=nodept(1,next)
40    if(lx.eq.ix(next) .or. ly.eq.iy(next)) go to 45
45    continue
      npts=npts+1
      ixx(npts)=ix(next)
      iyy(npts)=iy(next)
      lx=ix(next)
      ly=iy(next)
      iused(next)=1
      if(next.ne.nodest) go to 30
      npts=npts+1
      ixx(npts)=ixx(1)
      iyy(npts)=iyy(1)
ccc      write(15,47) lowcol,iused,(ixx(i),iyy(i),i=1,npts-1)
47    format(i3,1h=,8i1,1h=,18i4)
      do 46 i=1,npts
      iyy(i)=leny-1-iyy(i)     !  convert to screen units
      if(idev.ne.0) then       !  printer
         ixx(i)=ixx(i)+ixoff
         iyy(i)=iyy(i)+iyoff
      end if
46    continue
      call create_polygon@(ixx,iyy,npts,handle,error_code)
      if(error_code.eq.0) then
         call fill_polygon@(handle,icol2,error_code)
         call delete_polygon_definition@(handle,error_code)
      end if
      go to 100
50    if(nodept(2,next).eq.last) go to 35
      last=next
      next=nodept(2,next)
      go to 40
100   continue
101   do 105 i=1,8
105   iused(i)=0
      icol2=icol_16(lowcol)
      do 200 nodest=1,7,2
      zz=z((nodest+1)/2)
      if(con.lt.zz) go to 200   !  node is high color
      if(iused(nodest).ne.0) go to 200     !  already used
      npts=1
      ixx(npts)=ix(nodest)
      iyy(npts)=iy(nodest)
      lx=ix(nodest)
      ly=iy(nodest)
      iused(nodest)=1
      last=0
      next=nodest
130   if(nodept(2,next).ne.0) go to 150
135   last=next
      next=nodept(1,next)
140   if(lx.eq.ix(next) .or. ly.eq.iy(next)) go to 145
145   continue
      npts=npts+1
      ixx(npts)=ix(next)
      iyy(npts)=iy(next)
      lx=ix(next)
      ly=iy(next)
      iused(next)=1
      if(next.ne.nodest) go to 130
      npts=npts+1
      ixx(npts)=ixx(1)
      iyy(npts)=iyy(1)
ccc      write(15,147) lowcol,iused,(ixx(i),iyy(i),i=1,npts-1)
cc147    format(i3,1h=,8i1,1h=,18i4)
      do 146 i=1,npts
      iyy(i)=leny-1-iyy(i)     !  convert to screen units
      if(idev.ne.0) then       !  printer
         ixx(i)=ixx(i)+ixoff
         iyy(i)=iyy(i)+iyoff
      end if
146   continue
      call create_polygon@(ixx,iyy,npts,handle,error_code)
      if(error_code.eq.0) then
         call fill_polygon@(handle,icol2,error_code)
         call delete_polygon_definition@(handle,error_code)
      end if
      go to 200
150   if(nodept(2,next).eq.last) go to 135
      last=next
      next=nodept(2,next)
      go to 140
200   continue
      return
      end
c------------------------------------------------------------------
      subroutine interp(v1,v2,c,ix1,ix2,iy,ixx,iyy,iside)
      iside=0
      if(c.eq.v1 .and. c.eq.v2) return
      if(c.ge.v1 .and. c.lt.v2) go to 10
      if(c.ge.v2 .and. c.lt.v1) go to 10
      return
10    iside=1
      iyy=iy
      dv=v2-v1
      if(dv.eq.0.) f=.5
      if(dv.ne.0.) f=(c-v1)/dv
      ixx=ix1 + f*(ix2-ix1) + .5
      return
      end
c------------------------------------------------------------------
	subroutine remesh
      parameter (NGRID_DIM=361)
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)  
      COMMON /GRIDF/ Z(NGRID_DIM,NGRID_DIM)
	common /rundata/ xmin,ymin,dx,dy,nx,ny
	if(nx.ge.61 .and. ny.ge.61) return
ccc	if(nx.eq.121 .and. ny.eq.121) return
ccc	if(nx.eq.31 .and. ny.eq.31) return
	do 10 iy=1,ny
	do 10 ix=1,nx
 10	z(ix,iy)=grid(ix,iy)
	nxold=nx
	nyold=ny
	dxold=dx
	dyold=dy
	nx=61
	ny=61
ccc	nx=31
ccc	ny=31
	dx=float(nxold-1)*dxold/float(nx-1)
	dy=float(nyold-1)*dyold/float(ny-1)
	do 50 iy=1,ny
	y=ymin + float(iy-1)*dy
	u=(y-ymin)/dyold
	jy=u+1.000001
	u=u-jy+1
	do 50 ix=1,nx
	x=xmin + float(ix-1)*dx
	t=(x-xmin)/dxold
	jx=t+1.000001
	t=t-jx+1
	z1=z(jx  ,jy  )
	if(jx.lt.nxold) z2=z(jx+1,jy  )
	if(jx.lt.nxold .and. jy.lt.nyold) z3=z(jx+1,jy+1)
	if(jy.lt.nyold) z4=z(jx  ,jy+1)
50 	grid(ix,iy)=(1.-t)*(1.-u)*z1+t*(1.-u)*z2+t*u*z3+(1.-t)*u*z4
	return
	end
c------------------------------------------------------------------ 
